#Include "windows.bi"

#define ID_FILE_EXIT 9001
#define ID_STUFF_GO 9002

Const As String g_szClassName = "myWindowClass"

Dim Shared As HMODULE hInstance
Dim Shared As ZString Ptr lpCmdLine

Function WndProc(hwnd As HWND, Message As ULong, wParam As WPARAM, lParam As LPARAM) As LRESULT

	Select Case Message

		Case WM_CREATE
			Dim As HMENU hMenu, hSubMenu
			Dim As HICON hIcon, hIconSm

			hMenu = CreateMenu()

			hSubMenu = CreatePopupMenu()
			AppendMenu(hSubMenu, MF_STRING, ID_FILE_EXIT, "E&xit")
			AppendMenu(hMenu, MF_STRING Or MF_POPUP, Cast(UINT, hSubMenu), "&File")

			hSubMenu = CreatePopupMenu()
			AppendMenu(hSubMenu, MF_STRING, ID_STUFF_GO, "&Go")
			AppendMenu(hMenu, MF_STRING Or MF_POPUP, Cast(UINT, hSubMenu), "&Stuff")

			SetMenu(hwnd, hMenu)

			hIcon = LoadImage(NULL, "menu_two.ico", IMAGE_ICON, 32, 32, LR_LOADFROMFILE)
			If hIcon Then
				SendMessage(hwnd, WM_SETICON, ICON_BIG, Cast(LPARAM, hIcon))
			Else
				MessageBox(hwnd, "Could not load large icon! Is it in the current working directory?", "Error", MB_OK Or MB_ICONERROR)
			EndIf

			hIconSm = LoadImage(NULL, "menu_two.ico", IMAGE_ICON, 16, 16, LR_LOADFROMFILE)
			If hIconSm Then
				SendMessage(hwnd, WM_SETICON, ICON_SMALL, Cast(LPARAM, hIconSm))
			Else
				MessageBox(hwnd, "Could not load small icon! Is it in the current working directory?", "Error", MB_OK Or MB_ICONERROR)
			EndIf
		
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case ID_FILE_EXIT
					PostMessage(hwnd, WM_CLOSE, 0, 0)
				
				Case ID_STUFF_GO
					MessageBox(hwnd, "You clicked Go!", "Woo!", MB_OK)
			End Select
		
		Case WM_CLOSE
			DestroyWindow(hwnd)
		
		Case WM_DESTROY
			PostQuitMessage(0)
		
		Case Else
			Return DefWindowProc(hwnd, Message, wParam, lParam)
	End Select
	Return 0
End Function

Function WinMain(hInstance As HINSTANCE, hPrevInstance As HINSTANCE,	lpCmdLine As LPSTR, nCmdShow As Long) As Long
	Dim As WNDCLASSEX wc
	Dim As HWND hwnd
	Dim As MSG Msg

	wc.cbSize		     = SizeOf(WNDCLASSEX)
	wc.style		     = 0
	wc.lpfnWndProc	 = @WndProc
	wc.cbClsExtra	   = 0
	wc.cbWndExtra	   = 0
	wc.hInstance	   = hInstance
	wc.hIcon		     = NULL
	wc.hCursor		   = LoadCursor(NULL, IDC_ARROW)
	wc.hbrBackground = Cast(HBRUSH, COLOR_WINDOW + 1)
	wc.lpszMenuName  = NULL
	wc.lpszClassName = @g_szClassName
	wc.hIconSm		   = NULL

	If RegisterClassEx(@wc) = 0 Then
		MessageBox(NULL, "Window Registration Failed!", "Error!",	MB_ICONEXCLAMATION Or MB_OK)
		Return 0
	EndIf
	
	hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, _
	                  		g_szClassName, _
		                    "A Menu #2", _
		                    WS_OVERLAPPEDWINDOW, _
		                    CW_USEDEFAULT, CW_USEDEFAULT, 240, 120, _
		                    NULL, NULL, hInstance, NULL)

	If hwnd = NULL Then
		MessageBox(NULL, "Window Creation Failed!", "Error!",	MB_ICONEXCLAMATION Or MB_OK)
		Return 0
	EndIf

	ShowWindow(hwnd, nCmdShow)
	UpdateWindow(hwnd)

		Do While GetMessage(@msg,NULL,0,0)
		TranslateMessage(@msg)
		DispatchMessage(@msg)
	Loop
	Return msg.wParam
End Function

' Program start
hInstance = GetModuleHandle(NULL)
lpCmdLine = GetCommandLine
WinMain(hInstance, NULL, lpCmdLine, SW_SHOWDEFAULT)
ExitProcess(0)